
## protobuf 编译
### 环境安装:
```shell
go install google.golang.org/protobuf/cmd/protoc-gen-go
go install google.golang.org/grpc/cmd/protoc-gen-go-grpc
go install github.com/grpc-ecosystem/grpc-gateway/v2/protoc-gen-grpc-gateway
```

### proto 编译: 
```shell
protoc --go_out=. --go-grpc_out=. hello.proto  // 用go_package路径
protoc -I /Users/yuanzhaoyi/Develop/github.com/googleapis/googleapis -I . --go_out . --go_opt paths=source_relative --go-grpc_out . --grpc-gateway_out . hello.proto
```
```shell
protoc --go_out=. --go_opt=paths=source_relative --go-grpc_out=. --go-grpc_opt=paths=source_relative hello.proto  // 只用相对路径
```

## 测试
gateway测试
```shell
curl -X POST -k http://localhost:8090/v1/SayHello -d '{"name": " helloaaa"}'
```

## grpc 

listen.Accept 流程
```
循环处理连接，通过 lis.Accept 取出连接，如果队列中没有需处理的连接时，会形成阻塞等待。
若 lis.Accept 失败，则触发休眠机制，若为第一次失败那么休眠 5ms，否则翻倍，再次失败则不断翻倍直至上限休眠时间 1s，而休眠完毕后就会尝试去取下一个 “它”。
若 lis.Accept 成功，则重置休眠的时间计数和启动一个新的 goroutine 调用 handleRawConn 方法去执行/处理新的请求，也就是大家很喜欢说的 “每一个请求都是不同的 goroutine 在处理”。
在循环过程中，包含了 “退出” 服务的场景，主要是硬关闭和优雅重启服务两种情况。
```

## 参考
grpc-go: [https://grpc.io/docs/languages/go/quickstart/](https://grpc.io/docs/languages/go/quickstart/)
grpc-gateway: [https://grpc-ecosystem.github.io/grpc-gateway/](https://grpc-ecosystem.github.io/grpc-gateway/)
gooleapis proto: [https://github.com/googleapis/googleapis](https://github.com/googleapis/googleapis)